<template>
<v-container>
  <v-layout v-bind="layout">
    <v-flex xs6 class="pa-4">
      <login-enter/>
    </v-flex>
    <v-flex xs6 class="pa-4">
      <login-register />
    </v-flex>
  </v-layout>
</v-container>
</template>



<script>
import API from './api.ts';

export default {
  metaInfo: () => ({
    title: 'Вход / регистрация',
  }),
  computed: {
    api() {
      return window.api;
      // if (window.api)
      //   return window.api.user;
      // return null;
    },
    layout() {
      const layout = {};
      if (this.$vuetify.breakpoint.smAndDown) {
        layout.column = true;
      }
      return layout;
    },
  },
  components: {
    'login-enter': () => import('./LoginEnter.vue'),
    'login-register': () => import('./LoginRegister.vue'),
  },
  data: () => ({
    confirmCode: '',
    lastInvalidCode: '',
    loginform: {
      login: '', // can be email (and in future - a phone)
      password: '',
    },
    registrationStep: 1,
    resettingPassword: false,
    signinMsgErr: '',
    signupEmail: '',
    signupPassword: '',
    items: [
      {
        text: 'Главная',
        to: '/',
        disabled: false,
      },
      {
        text: 'Контакты',
        to: '/contacts',
        disabled: true,
      },
    ],
  }),
  methods: {
    resetPassword() {
      // todo: reset pass
    },
    showSigninError(msg) {
      this.$data.signinMsgErr = msg;
    },

    // "Confirm" button (Registration form)
    confirmAccount() {
      // TODO: confirm
      const api = new API();
      api.graphql({
        query: `mutation signup {
  signup(
    email: "${this.$data.signupEmail}",
    code: "${this.$data.confirmCode}",
    password: "${this.$data.signupPassword}"
) {
    email
    jwt
  }
}`,
        variable: null,
        // operationName: 'signup',
      }).then((response) => {
        const { data } = response;
        const { errors } = data;
        if (errors) {
          this.$data.lastInvalidCode = this.$data.confirmCode;
          errors.forEach((err) => {
            // err.message
          });
          // console.log(errors);
        } else {
          // User successfully activated his account
          // this.$data.registrationStep = 2;
        }
      });
    },

    // Register button
    register() {
      const api = new API();
      api.graphql({
        query: `mutation signup {
  signup(email: "${this.$data.signupEmail}") {
    email
    jwt
  }
}`,
        variable: null,
        // operationName: 'signup',
      }).then((response) => {
        const { data } = response;
        const { errors } = data;
        if (errors) {
          errors.forEach((err) => {
            // err.message
          });
          // console.log(errors);
        } else {
          // No errors - a really new email (new user)
          //
          // Check your mail and activate account
          this.$data.registrationStep = 2;
        }
      });
    },

    // "Login" button
    signin() {
      // console.log(this.$data.loginform);
      const api = new API();
      api.graphql({
        query: `mutation login {
  login(email: "${this.$data.loginform.login}", password: "${this.$data.loginform.password}") {
    email
    jwt
  }
}`,
        variable: null,
        // operationName: 'signup',
      }).then((response) => {
        // GraphQL "login" mutation OK
        const { data } = response;
        const { errors } = data;
        if (errors) {
          errors.forEach((err) => {
            // err.message
          });
          //
        } else {
          // No errors: email and password were valid!
          const user = data.data.login;
          // console.log(user);
          // this.$data.registrationStep = 2;
        }
      });
      // this.$data.lastloginform = this.$data.loginform;
      // api.post('/users/login', {
      // api.post('/auth/token', {
      //   // email: this.$data.loginform.email,
      //   // password: this.$data.loginform.password,
      // }).then((response) => {
      //   console.log(response);
      // });

      // axios.post('http://localhost:8000/auth/jwt/', {
      // api.post('/auth/token', {
      //   email: this.$data.loginform.email,
      //   password: this.$data.loginform.password,
      // })
      //   .then(response => {
      //     this.$tore.commit('LOGIN_SUCCESS', response);
      //     this.$router.push({ path: '/' });
      //   })
      //   .catch(error => {
      //     if (error.response) {
      //       // The request was made and the server responded with a status code
      //       // that falls out of the range of 2xx
      //       // console.log(error.response.data);
      //       // console.log(error.response.status);
      //       // console.log(error.response.headers);
      //       this.showSigninError(error.response.data);
      //     } else {
      //       this.showSigninError(error);
      //     }
      //   });
      // fetch(e.target.getAttribute('action'), {
      //   method: 'POST',
      //   credentials: 'include',
      //   headers: {
      //     // 'X-CSRFToken': getCookie('csrftoken'),
      //     Accept: 'application/json',
      //     'Content-type': 'application/x-www-form-urlencoded',
      //   },
      //   // body: serialize(formToJSON(form.elements)),
      // })
      //   .then(r => r.json())
      //   .then((data) => {
      //     if ('errors' in data) {
      //       // showFormErrors(data.errors, document.getElementById('login'));
      //     } else {
      //       // window.location.href = getURLParameter('next');
      //     }
      //   });
    },
    forgotPassword() {
      const { login } = this.$data.loginform;
      if (login) {
        this.$data.resettingPassword = true;
      } else {
        // Please enter email first
      }
    },
    sendRestorePasswordToken() {
      const api = new API();
      api.graphql({
        query: `mutation restorePassword {
  restorePassword(email: "${this.$data.loginform.login}") {
    email
    jwt
  }
}`,
        variable: null,
        // operationName: 'signup',
      }).then((response) => {
        // GraphQL "login" mutation OK
        const { data } = response;
        const { errors } = data;
        if (errors) {
          errors.forEach((err) => {
            // err.message
          });
          //
        } else {
          // No errors: email and password were valid!
          const user = data.data.login;
          // console.log(user);
        }
      });
    },
  },
};
</script>
